using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using NestedHtmlWriter;
using MagSiteLib;

namespace MagSite
{
	/// <summary>
	/// AdminResult ̊Tv̐łB
	/// </summary>
	public class AdminResult : System.Web.UI.Page
	{
#if false
		private void addKeyword( FullKeyword keyword )
		{
			if( Request["new"] == null )
			{
				error( keyword, "쐬L[[hw肳Ă܂B" );
				return;
			}
			if( Request["new"].Trim().Length == 0 )
			{
				error( keyword, "쐬L[[hw肳Ă܂B" );
				return;
			}
			if( Request["sk"] == null )
			{
				error( keyword, "쐬ZOw肳Ă܂B" );
				return;
			}
			if( Request["sk"].Trim().Length == 0 )
			{
				error( keyword, "쐬ZOw肳Ă܂B" );
				return;
			}

			string [] newKW = new string[keyword.Keywords.Length+1];
			for( int i=0; i<keyword.Keywords.Length; i++ )
			{
				newKW[i] = keyword.Keywords[i];
			}
			newKW[keyword.Keywords.Length] = Request["new"].Trim();
			FullKeyword newKeyword = new FullKeyword(newKW);
			string shortKeyword = Request["sk"].Trim();

			// ƃgbL[AꂪRec̃ACeXgɃL[[hǉ\
			SectionDef def = SectionDefManager.GetSectionDef(newKeyword);
			def.GetRawSectionDef().ShortKeyword = shortKeyword;
			def.Update();	// ƃgbL[AŃt@Cۑ邱ƂŁA
							// 񃍁[hɂ̃L[[hLɂȂ邱Ƃۏ؂B

			showMesssageSub(newKeyword,"L[[h:" + WriteLib.KeywordToHumanReadableString(newKeyword) + "̐VK쐬܂B");
		}

		private void fillShortKeyword()
		{
			ArrayList resultReport = new ArrayList();
			FullKeyword [] keywords = ItemListManager.ContentList.GetKeywordList();
			foreach( FullKeyword keyword in keywords )
			{
				if( keyword.IsRootKeyword() ) continue;
				if( keyword.IsNoKeyword() ) continue;
				SectionDef def = SectionDefManager.GetSectionDef(keyword);
				if( def.ShortKeyword == "" )
				{
					def.GetRawSectionDef().ShortKeyword = ShortKeywordFinder.GetNewShortKeyword();
					def.Update();
					resultReport.Add( string.Format("L[[h{0}ɒZO{1}蓖Ă܂B",
						WriteLib.KeywordToHumanReadableString(keyword),def.ShortKeyword) );
				}
			}
			showMesssageSub(FullKeyword.RootKeyword,(string[])resultReport.ToArray( typeof(string)));
		}

		private void showMesssageSub( FullKeyword keyword, string [] messages )
		{
			string title = "ʂ̃|[g";
			using( NhQuickDocument doc = new NhQuickDocument( Response.Output, 
					   title, "default.css", "text/css", Customize.DefaultLanguageCode, Customize.DocumentType ) )
			{
				using( NhHx h1 = doc.B.CreateHx(1) )
				{
					h1.WriteText(title);
				}

				foreach( string message in messages )
				{
					doc.B.WritePText(message);
				}
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void showMesssageSub( FullKeyword keyword, string message )
		{
			string [] messages = { message };
			showMesssageSub( keyword, messages );
		}

		private void showMesssage( FullKeyword keyword )
		{
			string message = "(bZ[W͂܂)";
			if( Request["msg"] != null )
			{
				message = Request["msg"];
			}

			showMesssageSub(keyword,message);
		}
#endif

		private void error( FullKeyword keyword, string message )
		{
			string title = "G[";
			using( NhQuickDocument doc = new NhQuickDocument( Response.Output, 
					   title, "default.css", "text/css", Customize.DefaultLanguageCode, Customize.DocumentType ) )
			{
				doc.B.WriteHxText(1,title);
				doc.B.WritePText(message);
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteAdminFooter(doc.B,keyword);
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request);

			switch( URIQueryParser.ParseFn(Request) )
			{
#if false
				case "addkw":
					addKeyword(keyword);
					break;
				case "fillShortKW":
					fillShortKeyword();
					break;
				case "":
					showMesssage(keyword);
					break;
#endif
				default:
					error(keyword,"m̋@\w肳܂B͍s܂B");
					break;
			}
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
